| AAX SDK 2.6.1 Avid Audio Extensions Development Kit

- Welcome
- Manual
- Classes
- Files
- Lists
- Support

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
List of all members | Public Types | Public Member Functions
AAX_CParameter< T > Class Template Reference
AAX SDK Manual » AAX Library features » Parameter Manager

`#include <AAX_CParameter.h>`

Inheritance diagram for AAX_CParameter< T >:
[legend]
Collaboration diagram for AAX_CParameter< T >:
[legend]

## Description

template<typename T>
class AAX_CParameter< T >

Generic implementation of an AAX_IParameter.

This is a concrete, templatized implementation of AAX_IParameter for parameters with standard types such as `float`, `uint32`, `bool`, etc.

Many different behaviors can be composited into this class as delegates. AAX_ITaperDelegate and AAX_IDisplayDelegate are two examples of delegates that this class uses in order to apply custom behaviors to the AAX_IParameter interface.

Plug-in developers can subclass these delegates to create adaptable, reusable parameter behaviors, which can then be "mixed in" to individual AAX_CParameter objects without the need to modify the objects themselves.

Note
  Because AAX_CParameter is a C++ template, each AAX_CParameter template parameter that is used creates a new subclass that adheres to the AAX_IParameter interface.

## Public Types
enum | Type { eParameterTypeUndefined = 0 , eParameterTypeBool = 1 , eParameterTypeInt32 = 2 , eParameterTypeFloat = 3 , eParameterTypeCustom = 4 }
enum | Defaults { eParameterDefaultNumStepsDiscrete = 2 , eParameterDefaultNumStepsContinuous = 128 }

## Public Member Functions
| AAX_CParameter (AAX_CParamID identifier, const AAX_IString &name, T defaultValue, const AAX_ITaperDelegate< T > &taperDelegate, const AAX_IDisplayDelegate< T > &displayDelegate, bool automatable=false)
| Constructs an AAX_CParameter object using the specified taper and display delegates.
| AAX_CParameter (const AAX_IString &identifier, const AAX_IString &name, T defaultValue, const AAX_ITaperDelegate< T > &taperDelegate, const AAX_IDisplayDelegate< T > &displayDelegate, bool automatable=false)
| Constructs an AAX_CParameter object using the specified taper and display delegates.
| AAX_CParameter (const AAX_IString &identifier, const AAX_IString &name, T defaultValue, bool automatable=false)
| Constructs an AAX_CParameter object with no delegates.
| AAX_CParameter (const AAX_IString &identifier, const AAX_IString &name, bool automatable=false)
| Constructs an AAX_CParameter object with no delegates or default value.
| AAX_DEFAULT_MOVE_CTOR (AAX_CParameter)
| AAX_DEFAULT_MOVE_OPER (AAX_CParameter)
| AAX_DELETE (AAX_CParameter())
| AAX_DELETE (AAX_CParameter(const AAX_CParameter &other))
| AAX_DELETE (AAX_CParameter &operator=(const AAX_CParameter &other))
| ~AAX_CParameter () AAX_OVERRIDE
| Virtual destructor used to delete all locally allocated pointers.
AAX_IParameterValue * | CloneValue () const AAX_OVERRIDE
| Clone the parameter's value to a new AAX_IParameterValue object.
bool | GetValueAsString (AAX_IString *) const
| Retrieves the parameter's value as a string.
bool | SetValueWithBool (bool value)
| Sets the parameter's value as a bool.
bool | SetValueWithInt32 (int32_t value)
| Sets the parameter's value as an int32_t.
bool | SetValueWithFloat (float value)
| Sets the parameter's value as a float.
bool | SetValueWithDouble (double value)
| Sets the parameter's value as a double.
bool | SetValueWithString (const AAX_IString &value)
| Sets the parameter's value as a string.
bool | GetNormalizedValueFromBool (bool value, double *normalizedValue) const
| Converts a bool to a normalized parameter value.
bool | GetNormalizedValueFromInt32 (int32_t value, double *normalizedValue) const
| Converts an integer to a normalized parameter value.
bool | GetNormalizedValueFromFloat (float value, double *normalizedValue) const
| Converts a float to a normalized parameter value.
bool | GetNormalizedValueFromDouble (double value, double *normalizedValue) const
| Converts a double to a normalized parameter value.
bool | GetBoolFromNormalizedValue (double inNormalizedValue, bool *value) const
| Converts a normalized parameter value to a bool representing the corresponding real value.
bool | GetInt32FromNormalizedValue (double inNormalizedValue, int32_t *value) const
| Converts a normalized parameter value to an integer representing the corresponding real value.
bool | GetFloatFromNormalizedValue (double inNormalizedValue, float *value) const
| Converts a normalized parameter value to a float representing the corresponding real value.
bool | GetDoubleFromNormalizedValue (double inNormalizedValue, double *value) const
| Converts a normalized parameter value to a double representing the corresponding real value.
Identification methods
AAX_CParamID | Identifier () const AAX_OVERRIDE
| Returns the parameter's unique identifier.
void | SetName (const AAX_CString &name) AAX_OVERRIDE
| Sets the parameter's display name.
const AAX_CString & | Name () const AAX_OVERRIDE
| Returns the parameter's display name.
void | AddShortenedName (const AAX_CString &name) AAX_OVERRIDE
| Sets the parameter's shortened display name.
const AAX_CString & | ShortenedName (int32_t iNumCharacters) const AAX_OVERRIDE
| Returns the parameter's shortened display name.
void | ClearShortenedNames () AAX_OVERRIDE
| Clears the internal list of shortened display names.
Taper methods
void | SetNormalizedDefaultValue (double normalizedDefault) AAX_OVERRIDE
| Sets the parameter's default value using its normalized representation.
double | GetNormalizedDefaultValue () const AAX_OVERRIDE
| Returns the normalized representation of the parameter's real default value.
void | SetToDefaultValue () AAX_OVERRIDE
| Restores the state of this parameter to its default value.
void | SetNormalizedValue (double newNormalizedValue) AAX_OVERRIDE
| Sets a parameter value using it's normalized representation.
double | GetNormalizedValue () const AAX_OVERRIDE
| Returns the normalized representation of the parameter's current real value.
void | SetNumberOfSteps (uint32_t numSteps) AAX_OVERRIDE
| Sets the number of discrete steps for this parameter.
uint32_t | GetNumberOfSteps () const AAX_OVERRIDE
| Returns the number of discrete steps used by the parameter.
uint32_t | GetStepValue () const AAX_OVERRIDE
| Returns the current step for the current value of the parameter.
double | GetNormalizedValueFromStep (uint32_t iStep) const AAX_OVERRIDE
| Returns the normalized value for a given step.
uint32_t | GetStepValueFromNormalizedValue (double normalizedValue) const AAX_OVERRIDE
| Returns the step value for a normalized value of the parameter.
void | SetStepValue (uint32_t iStep) AAX_OVERRIDE
| Returns the current step for the current value of the parameter.
void | SetType (AAX_EParameterType iControlType) AAX_OVERRIDE
| Sets the type of this parameter.
AAX_EParameterType | GetType () const AAX_OVERRIDE
| Returns the type of this parameter as an AAX_EParameterType.
void | SetOrientation (AAX_EParameterOrientation iOrientation) AAX_OVERRIDE
| Sets the orientation of this parameter.
AAX_EParameterOrientation | GetOrientation () const AAX_OVERRIDE
| Returns the orientation of this parameter.
void | SetTaperDelegate (AAX_ITaperDelegateBase &inTaperDelegate, bool inPreserveValue=true) AAX_OVERRIDE
| Sets the parameter's taper delegate.
Display methods
void | SetDisplayDelegate (AAX_IDisplayDelegateBase &inDisplayDelegate) AAX_OVERRIDE
| Sets the parameter's display delegate.
bool | GetValueString (AAX_CString *valueString) const AAX_OVERRIDE
| Serializes the parameter value into a string.
bool | GetValueString (int32_t iMaxNumChars, AAX_CString *valueString) const AAX_OVERRIDE
| Serializes the parameter value into a string, size hint included.
bool | GetNormalizedValueFromBool (bool value, double *normalizedValue) const AAX_OVERRIDE
| Converts a bool to a normalized parameter value.
bool | GetNormalizedValueFromInt32 (int32_t value, double *normalizedValue) const AAX_OVERRIDE
| Converts an integer to a normalized parameter value.
bool | GetNormalizedValueFromFloat (float value, double *normalizedValue) const AAX_OVERRIDE
| Converts a float to a normalized parameter value.
bool | GetNormalizedValueFromDouble (double value, double *normalizedValue) const AAX_OVERRIDE
| Converts a double to a normalized parameter value.
bool | GetNormalizedValueFromString (const AAX_CString &valueString, double *normalizedValue) const AAX_OVERRIDE
| Converts a given string to a normalized parameter value.
bool | GetBoolFromNormalizedValue (double normalizedValue, bool *value) const AAX_OVERRIDE
| Converts a normalized parameter value to a bool representing the corresponding real value.
bool | GetInt32FromNormalizedValue (double normalizedValue, int32_t *value) const AAX_OVERRIDE
| Converts a normalized parameter value to an integer representing the corresponding real value.
bool | GetFloatFromNormalizedValue (double normalizedValue, float *value) const AAX_OVERRIDE
| Converts a normalized parameter value to a float representing the corresponding real value.
bool | GetDoubleFromNormalizedValue (double normalizedValue, double *value) const AAX_OVERRIDE
| Converts a normalized parameter value to a double representing the corresponding real value.
bool | GetStringFromNormalizedValue (double normalizedValue, AAX_CString &valueString) const AAX_OVERRIDE
| Converts a normalized parameter value to a string representing the corresponding real value.
bool | GetStringFromNormalizedValue (double normalizedValue, int32_t iMaxNumChars, AAX_CString &valueString) const AAX_OVERRIDE
| Converts a normalized parameter value to a string representing the corresponding real, size hint included. value.
bool | SetValueFromString (const AAX_CString &newValueString) AAX_OVERRIDE
| Converts a string to a real parameter value and sets the parameter to this value.
Automation methods
void | SetAutomationDelegate (AAX_IAutomationDelegate *iAutomationDelegate) AAX_OVERRIDE
| Sets the automation delegate (if one is required)
bool | Automatable () const AAX_OVERRIDE
| Returns true if the parameter is automatable, false if it is not.
void | Touch () AAX_OVERRIDE
| Signals the automation system that a control has been touched.
void | Release () AAX_OVERRIDE
| Signals the automation system that a control has been released.
Typed accessors
bool | GetValueAsBool (bool *value) const AAX_OVERRIDE
| Retrieves the parameter's value as a bool.
bool | GetValueAsInt32 (int32_t *value) const AAX_OVERRIDE
| Retrieves the parameter's value as an int32_t.
bool | GetValueAsFloat (float *value) const AAX_OVERRIDE
| Retrieves the parameter's value as a float.
bool | GetValueAsDouble (double *value) const AAX_OVERRIDE
| Retrieves the parameter's value as a double.
bool | GetValueAsString (AAX_IString *value) const AAX_OVERRIDE
| Retrieves the parameter's value as a string.
bool | SetValueWithBool (bool value) AAX_OVERRIDE
| Sets the parameter's value as a bool.
bool | SetValueWithInt32 (int32_t value) AAX_OVERRIDE
| Sets the parameter's value as an int32_t.
bool | SetValueWithFloat (float value) AAX_OVERRIDE
| Sets the parameter's value as a float.
bool | SetValueWithDouble (double value) AAX_OVERRIDE
| Sets the parameter's value as a double.
bool | SetValueWithString (const AAX_IString &value) AAX_OVERRIDE
| Sets the parameter's value as a string.
Host interface methods
void | UpdateNormalizedValue (double newNormalizedValue) AAX_OVERRIDE
| Sets the parameter's state given a normalized value.
Public Member Functions inherited from AAX_IParameter
virtual | ~AAX_IParameter ()
| Virtual destructor.
virtual AAX_IParameterValue * | CloneValue () const =0
| Clone the parameter's value to a new AAX_IParameterValue object.

## Direct methods on AAX_CParameter
These methods can be used to access the parameter's state and properties. These methods are specific to the concrete AAX_CParameter class and are not part of the AAX_IParameter interface.
AAX_CStringAbbreviations | mNames
bool | mAutomatable
uint32_t | mNumSteps
AAX_EParameterType | mControlType
AAX_EParameterOrientation | mOrientation
AAX_ITaperDelegate< T > * | mTaperDelegate
AAX_IDisplayDelegate< T > * | mDisplayDelegate
AAX_IAutomationDelegate * | mAutomationDelegate
bool | mNeedNotify
AAX_CParameterValue< T > | mValue
T | mDefaultValue
void | SetValue (T newValue)
| Initiates a host request to set the parameter's value.
T | GetValue () const
| Returns the parameter's value.
void | SetDefaultValue (T newDefaultValue)
| Set the parameter's default value.
T | GetDefaultValue () const
| Returns the parameter's default value.
const AAX_ITaperDelegate< T > * | TaperDelegate () const
| Returns a reference to the parameter's taper delegate.
const AAX_IDisplayDelegate< T > * | DisplayDelegate () const
| Returns a reference to the parameter's display delegate.

## Member Enumeration Documentation

## ◆ Type

template<typename T >

enum AAX_CParameter::Type

Enumerator
eParameterTypeUndefined |
eParameterTypeBool |
eParameterTypeInt32 |
eParameterTypeFloat |
eParameterTypeCustom |

## ◆ Defaults

template<typename T >

enum AAX_CParameter::Defaults

Enumerator
eParameterDefaultNumStepsDiscrete |
eParameterDefaultNumStepsContinuous |

## Constructor & Destructor Documentation

## ◆ AAX_CParameter() [1/4]

template<typename T >

AAX_CParameter< T >::AAX_CParameter | ( | AAX_CParamID | identifier,
|  | const AAX_IString & | name,
|  | T | defaultValue,
|  | const AAX_ITaperDelegate< T > & | taperDelegate,
|  | const AAX_IDisplayDelegate< T > & | displayDelegate,
|  | bool | automatable = `false`
| ) |  |

Constructs an AAX_CParameter object using the specified taper and display delegates.

The delegates are passed in by reference to prevent ambiguities of object ownership. For more information about `identifer` and `name`, please consult the base AAX_IParameter interface.

Parameters

  [in] | identifier | Unique ID for the parameter, these can only be 31 characters long at most. (the fixed length is a requirement for some optimizations in the host)
  [in] | name | The parameter's unabbreviated display name
  [in] | defaultValue | The parameter's default value
  [in] | taperDelegate | A delegate representing the parameter's taper behavior
  [in] | displayDelegate | A delegate representing the parameter's display conversion behavior
  [in] | automatable | A flag to set whether the parameter will be visible to the host's automation system

Note
  Upon construction, the state (value) of the parameter will be the default value, as established by the provided `taperDelegate`.

Host Compatibility Notes:

  As of Pro Tools 10.2, DAE will check for a matching parameter NAME and not an ID when reading in automation data from a session saved with an AAX plug-ins RTAS/TDM counter part.

  As of Pro Tools 11.1, AAE will first try to match ID. If that fails, AAE will fall back to matching by Name.

References AAX_CParameter< T >::SetToDefaultValue().

Here is the call graph for this function:

## ◆ AAX_CParameter() [2/4]

template<typename T >

AAX_CParameter< T >::AAX_CParameter | ( | const AAX_IString & | identifier,
|  | const AAX_IString & | name,
|  | T | defaultValue,
|  | const AAX_ITaperDelegate< T > & | taperDelegate,
|  | const AAX_IDisplayDelegate< T > & | displayDelegate,
|  | bool | automatable = `false`
| ) |  |

Constructs an AAX_CParameter object using the specified taper and display delegates.

This constructor uses an AAX_IString for the parameter identifier, which can be a more flexible solution for some plug-ins.

References AAX_CParameter< T >::SetToDefaultValue().

Here is the call graph for this function:

## ◆ AAX_CParameter() [3/4]

template<typename T >

AAX_CParameter< T >::AAX_CParameter | ( | const AAX_IString & | identifier,
|  | const AAX_IString & | name,
|  | T | defaultValue,
|  | bool | automatable = `false`
| ) |  |

Constructs an AAX_CParameter object with no delegates.

Delegates may be set on this object after construction. Most parameter operations will not work until after delegages have been set.

- See also
    AAX_CParameter::SetTaperDelegate()
- See also
    AAX_CParameter::SetDisplayDelegate()

References AAX_CParameter< T >::SetToDefaultValue().

Here is the call graph for this function:

## ◆ AAX_CParameter() [4/4]

template<typename T >

AAX_CParameter< T >::AAX_CParameter | ( | const AAX_IString & | identifier,
|  | const AAX_IString & | name,
|  | bool | automatable = `false`
| ) |  |

Constructs an AAX_CParameter object with no delegates or default value.

Delegates and default value may be set on this object after construction. Most parameter operations will not work until after delegages have been set.

- See also
    AAX_CParameter::SetDefaultValue()
- See also
    AAX_CParameter::SetTaperDelegate()
- See also
    AAX_CParameter::SetDisplayDelegate()

References AAX_CParameter< T >::SetToDefaultValue().

Here is the call graph for this function:

## ◆ ~AAX_CParameter()

template<typename T >

AAX_CParameter< T >::~AAX_CParameter

Virtual destructor used to delete all locally allocated pointers.

## Member Function Documentation

## ◆ AAX_DEFAULT_MOVE_CTOR()

template<typename T >

AAX_CParameter< T >::AAX_DEFAULT_MOVE_CTOR | ( | AAX_CParameter< T > |  | ) |

Move constructor and move assignment operator are allowed

## ◆ AAX_DEFAULT_MOVE_OPER()

template<typename T >

AAX_CParameter< T >::AAX_DEFAULT_MOVE_OPER | ( | AAX_CParameter< T > |  | ) |

## ◆ AAX_DELETE() [1/3]

template<typename T >

AAX_CParameter< T >::AAX_DELETE | ( | AAX_CParameter< T >() |  | ) |

Default constructor not allowed, except by possible wrappering classes.

## ◆ AAX_DELETE() [2/3]

template<typename T >

AAX_CParameter< T >::AAX_DELETE | ( | AAX_CParameter< T >(const AAX_CParameter< T > &other) |  | ) |

## ◆ AAX_DELETE() [3/3]

template<typename T >

AAX_CParameter< T >::AAX_DELETE | ( | AAX_CParameter< T > & | operator = `(const AAX_CParameter< T > &other)` | ) |

## ◆ CloneValue()

template<typename T >

AAX_IParameterValue * AAX_CParameter< T >::CloneValue
| virtual

Clone the parameter's value to a new AAX_IParameterValue object.

The returned object is independent from the AAX_IParameter. For example, changing the state of the returned object will not result in a change to the original AAX_IParameter.

Implements AAX_IParameter.

## ◆ Identifier()

template<typename T >

AAX_CParamID AAX_CParameter< T >::Identifier
| virtual

Returns the parameter's unique identifier.

This unique ID is used by the Parameter Manager and by outside applications to uniquely identify and target control messages. This value may not be changed after the parameter has been constructed.

Implements AAX_IParameter.

## ◆ SetName()

template<typename T >

void AAX_CParameter< T >::SetName | ( | const AAX_CString & | name | ) |
| virtual

Sets the parameter's display name.

This name is used for display only, it is not used for indexing or identifying the parameter This name may be changed after the parameter has been created, but display name changes may not be recognized by all AAX hosts.

Parameters

  [in] | name | Display name that will be assigned to the parameter

Implements AAX_IParameter.

## ◆ Name()

template<typename T >

const AAX_CString & AAX_CParameter< T >::Name
| virtual

Returns the parameter's display name.

Note
  This method returns a const reference in order to prevent a string copy. Do not cast away the const to change this value.

Implements AAX_IParameter.

## ◆ AddShortenedName()

template<typename T >

void AAX_CParameter< T >::AddShortenedName | ( | const AAX_CString & | name | ) |
| virtual

Sets the parameter's shortened display name.

This name is used for display only, it is not used for indexing or identifying the parameter These names show up when the host asks for shorter length parameter names for display on Control Surfaces or other string length constrained situations.

Parameters

  [in] | name | Shortened display names that will be assigned to the parameter

Implements AAX_IParameter.

## ◆ ShortenedName()

template<typename T >

const AAX_CString & AAX_CParameter< T >::ShortenedName | ( | int32_t | iNumCharacters | ) | const
| virtual

Returns the parameter's shortened display name.

Note
  This method returns a const reference in order to prevent a string copy. Do not cast away the const to change this value.

Implements AAX_IParameter.

References AAX_CString::Get().

Here is the call graph for this function:

## ◆ ClearShortenedNames()

template<typename T >

void AAX_CParameter< T >::ClearShortenedNames
| virtual

Clears the internal list of shortened display names.

Implements AAX_IParameter.

## ◆ SetNormalizedDefaultValue()

template<typename T >

void AAX_CParameter< T >::SetNormalizedDefaultValue | ( | double | normalizedDefault | ) |
| virtual

Sets the parameter's default value using its normalized representation.

Implements AAX_IParameter.

## ◆ GetNormalizedDefaultValue()

template<typename T >

double AAX_CParameter< T >::GetNormalizedDefaultValue
| virtual

Returns the normalized representation of the parameter's real default value.

Implements AAX_IParameter.

## ◆ SetToDefaultValue()

template<typename T >

void AAX_CParameter< T >::SetToDefaultValue
| virtual

Restores the state of this parameter to its default value.

Implements AAX_IParameter.

Referenced by AAX_CParameter< T >::AAX_CParameter().

Here is the caller graph for this function:

## ◆ SetNormalizedValue()

template<typename T >

void AAX_CParameter< T >::SetNormalizedValue | ( | double | newNormalizedValue | ) |
| virtual

Sets a parameter value using it's normalized representation.

For more information regarding normalized values, see Parameter Manager

Parameters

  [in] | newNormalizedValue | New value (normalized) to which the parameter will be set

Implements AAX_IParameter.

## ◆ GetNormalizedValue()

template<typename T >

double AAX_CParameter< T >::GetNormalizedValue
| virtual

Returns the normalized representation of the parameter's current real value.

Implements AAX_IParameter.

## ◆ SetNumberOfSteps()

template<typename T >

void AAX_CParameter< T >::SetNumberOfSteps | ( | uint32_t | numSteps | ) |
| virtual

Sets the number of discrete steps for this parameter.

Stepped parameter values are useful for discrete parameters and for "jumping" events such as mouse wheels, page up/down, etc. The parameter's step size is used to specify the coarseness of those changes.

Note
  numSteps MUST be greater than zero. All other values may be considered an error by the host.

Parameters

  [in] | numSteps | The number of steps that the parameter will use

Implements AAX_IParameter.

References AAX_ASSERT.

## ◆ GetNumberOfSteps()

template<typename T >

uint32_t AAX_CParameter< T >::GetNumberOfSteps
| virtual

Returns the number of discrete steps used by the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implements AAX_IParameter.

## ◆ GetStepValue()

template<typename T >

uint32_t AAX_CParameter< T >::GetStepValue
| virtual

Returns the current step for the current value of the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromStep()

template<typename T >

double AAX_CParameter< T >::GetNormalizedValueFromStep | ( | uint32_t | iStep | ) | const
| virtual

Returns the normalized value for a given step.

See SetNumberOfSteps() for more information about parameter steps.

Implements AAX_IParameter.

## ◆ GetStepValueFromNormalizedValue()

template<typename T >

uint32_t AAX_CParameter< T >::GetStepValueFromNormalizedValue | ( | double | normalizedValue | ) | const
| virtual

Returns the step value for a normalized value of the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implements AAX_IParameter.

## ◆ SetStepValue()

template<typename T >

void AAX_CParameter< T >::SetStepValue | ( | uint32_t | iStep | ) |
| virtual

Returns the current step for the current value of the parameter.

See SetNumberOfSteps() for more information about parameter steps.

Implements AAX_IParameter.

## ◆ SetType()

template<typename T >

void AAX_CParameter< T >::SetType | ( | AAX_EParameterType | iControlType | ) |
| virtual

Sets the type of this parameter.

See GetType for use cases

Parameters

  [in] | iControlType | The parameter's new type as an AAX_EParameterType

Implements AAX_IParameter.

## ◆ GetType()

template<typename T >

AAX_EParameterType AAX_CParameter< T >::GetType
| virtual

Returns the type of this parameter as an AAX_EParameterType.

Todo:
  Document use cases for control type

Implements AAX_IParameter.

## ◆ SetOrientation()

template<typename T >

void AAX_CParameter< T >::SetOrientation | ( | AAX_EParameterOrientation | iOrientation | ) |
| virtual

Sets the orientation of this parameter.

Parameters

  [in] | iOrientation | The parameter's new orientation

Implements AAX_IParameter.

## ◆ GetOrientation()

template<typename T >

AAX_EParameterOrientation AAX_CParameter< T >::GetOrientation
| virtual

Returns the orientation of this parameter.

Implements AAX_IParameter.

## ◆ SetTaperDelegate()

template<typename T >

void AAX_CParameter< T >::SetTaperDelegate | ( | AAX_ITaperDelegateBase & | inTaperDelegate,
|  | bool | inPreserveValue = `true`
| ) |  |
| virtual

Sets the parameter's taper delegate.

Parameters

  [in] | inTaperDelegate | A reference to the parameter's new taper delegate
  [in] | inPreserveValue |

Todo:
  Document this parameter

Implements AAX_IParameter.

References AAX_ITaperDelegate< T >::Clone().

Here is the call graph for this function:

## ◆ SetDisplayDelegate()

template<typename T >

void AAX_CParameter< T >::SetDisplayDelegate | ( | AAX_IDisplayDelegateBase & | inDisplayDelegate | ) |
| virtual

Sets the parameter's display delegate.

Parameters

  [in] | inDisplayDelegate | A reference to the parameter's new display delegate

Implements AAX_IParameter.

References AAX_IDisplayDelegate< T >::Clone().

Here is the call graph for this function:

## ◆ GetValueString() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetValueString | ( | AAX_CString * | valueString | ) | const
| virtual

Serializes the parameter value into a string.

Parameters

  [out] | valueString | A string representing the parameter's real value

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetValueString() [2/2]

template<typename T >

bool AAX_CParameter< T >::GetValueString | ( | int32_t | iMaxNumChars,
|  | AAX_CString * | valueString
| ) |  | const
| virtual

Serializes the parameter value into a string, size hint included.

Parameters

  [in] | iMaxNumChars | A size hint for the size of the string being requested. Useful for control surfaces and other limited area text fields. (make sure that size of desired string also has room for null termination)
  [out] | valueString | A string representing the parameter's real value

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromBool() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetNormalizedValueFromBool | ( | bool | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts a bool to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromInt32() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetNormalizedValueFromInt32 | ( | int32_t | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts an integer to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromFloat() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetNormalizedValueFromFloat | ( | float | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts a float to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromDouble() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetNormalizedValueFromDouble | ( | double | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts a double to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromString()

template<typename T >

bool AAX_CParameter< T >::GetNormalizedValueFromString | ( | const AAX_CString & | valueString,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts a given string to a normalized parameter value.

Parameters

  [in] | valueString | A string representing a possible real value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with valueString

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetBoolFromNormalizedValue() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetBoolFromNormalizedValue | ( | double | normalizedValue,
|  | bool * | value
| ) |  | const
| virtual

Converts a normalized parameter value to a bool representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to bool was successful
  false | The conversion to bool was unsuccessful

Implements AAX_IParameter.

## ◆ GetInt32FromNormalizedValue() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetInt32FromNormalizedValue | ( | double | normalizedValue,
|  | int32_t * | value
| ) |  | const
| virtual

Converts a normalized parameter value to an integer representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to int32_t was successful
  false | The conversion to int32_t was unsuccessful

Implements AAX_IParameter.

## ◆ GetFloatFromNormalizedValue() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetFloatFromNormalizedValue | ( | double | normalizedValue,
|  | float * | value
| ) |  | const
| virtual

Converts a normalized parameter value to a float representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to float was successful
  false | The conversion to float was unsuccessful

Implements AAX_IParameter.

## ◆ GetDoubleFromNormalizedValue() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetDoubleFromNormalizedValue | ( | double | normalizedValue,
|  | double * | value
| ) |  | const
| virtual

Converts a normalized parameter value to a double representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to double was successful
  false | The conversion to double was unsuccessful

Implements AAX_IParameter.

## ◆ GetStringFromNormalizedValue() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetStringFromNormalizedValue | ( | double | normalizedValue,
|  | AAX_CString & | valueString
| ) |  | const
| virtual

Converts a normalized parameter value to a string representing the corresponding real value.

Parameters

  [in] | normalizedValue | A normalized parameter value
  [out] | valueString | A string representing the parameter value associated with normalizedValue

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetStringFromNormalizedValue() [2/2]

template<typename T >

bool AAX_CParameter< T >::GetStringFromNormalizedValue | ( | double | normalizedValue,
|  | int32_t | iMaxNumChars,
|  | AAX_CString & | valueString
| ) |  | const
| virtual

Converts a normalized parameter value to a string representing the corresponding real, size hint included. value.

Parameters

  [in] | normalizedValue | A normalized parameter value
  [in] | iMaxNumChars | A size hint for the size of the string being requested. Useful for control surfaces and other limited area text fields. (make sure that size of desired string also has room for null termination)
  [out] | valueString | A string representing the parameter value associated with normalizedValue

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueFromString()

template<typename T >

bool AAX_CParameter< T >::SetValueFromString | ( | const AAX_CString & | newValueString | ) |
| virtual

Converts a string to a real parameter value and sets the parameter to this value.

Parameters

  [in] | newValueString | A string representing the parameter's new real value

Return values

  true | The string conversion was successful
  false | The string conversion was unsuccessful

Implements AAX_IParameter.

## ◆ SetAutomationDelegate()

template<typename T >

void AAX_CParameter< T >::SetAutomationDelegate | ( | AAX_IAutomationDelegate * | iAutomationDelegate | ) |
| virtual

Sets the automation delegate (if one is required)

Parameters

  [in] | iAutomationDelegate | A reference to the parameter manager's automation delegate interface

Implements AAX_IParameter.

References AAX_IAutomationDelegate::RegisterParameter().

Here is the call graph for this function:

## ◆ Automatable()

template<typename T >

bool AAX_CParameter< T >::Automatable
| virtual

Returns true if the parameter is automatable, false if it is not.

Note
  Subclasses that return true in this method must support host-based automation.

Implements AAX_IParameter.

## ◆ Touch()

template<typename T >

void AAX_CParameter< T >::Touch
| virtual

Signals the automation system that a control has been touched.

Call this method in response to GUI events that begin editing, such as a mouse down. After this method has been called you are free to call SetNormalizedValue() as much as you need, e.g. in order to respond to subsequent mouse moved events. Call Release() to free the parameter for updates from other controls.

Implements AAX_IParameter.

## ◆ Release()

template<typename T >

void AAX_CParameter< T >::Release
| virtual

Signals the automation system that a control has been released.

Call this method in response to GUI events that complete editing, such as a mouse up. Once this method has been called you should not call SetNormalizedValue() again until after the next call to Touch().

Implements AAX_IParameter.

## ◆ GetValueAsBool()

template<typename T >

bool AAX_CParameter< T >::GetValueAsBool | ( | bool * | value | ) | const
| virtual

Retrieves the parameter's value as a bool.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to bool was successful
  false | The conversion to bool was unsuccessful

Implements AAX_IParameter.

## ◆ GetValueAsInt32()

template<typename T >

bool AAX_CParameter< T >::GetValueAsInt32 | ( | int32_t * | value | ) | const
| virtual

Retrieves the parameter's value as an int32_t.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to int32_t was successful
  false | The conversion to int32_t was unsuccessful

Implements AAX_IParameter.

## ◆ GetValueAsFloat()

template<typename T >

bool AAX_CParameter< T >::GetValueAsFloat | ( | float * | value | ) | const
| virtual

Retrieves the parameter's value as a float.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to float was successful
  false | The conversion to float was unsuccessful

Implements AAX_IParameter.

## ◆ GetValueAsDouble()

template<typename T >

bool AAX_CParameter< T >::GetValueAsDouble | ( | double * | value | ) | const
| virtual

Retrieves the parameter's value as a double.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to double was successful
  false | The conversion to double was unsuccessful

Implements AAX_IParameter.

## ◆ GetValueAsString() [1/2]

template<typename T >

bool AAX_CParameter< T >::GetValueAsString | ( | AAX_IString * | value | ) | const
| virtual

Retrieves the parameter's value as a string.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to string was successful
  false | The conversion to string was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithBool() [1/2]

template<typename T >

bool AAX_CParameter< T >::SetValueWithBool | ( | bool | value | ) |
| virtual

Sets the parameter's value as a bool.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from bool was successful
  false | The conversion from bool was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithInt32() [1/2]

template<typename T >

bool AAX_CParameter< T >::SetValueWithInt32 | ( | int32_t | value | ) |
| virtual

Sets the parameter's value as an int32_t.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from int32_t was successful
  false | The conversion from int32_t was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithFloat() [1/2]

template<typename T >

bool AAX_CParameter< T >::SetValueWithFloat | ( | float | value | ) |
| virtual

Sets the parameter's value as a float.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from float was successful
  false | The conversion from float was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithDouble() [1/2]

template<typename T >

bool AAX_CParameter< T >::SetValueWithDouble | ( | double | value | ) |
| virtual

Sets the parameter's value as a double.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from double was successful
  false | The conversion from double was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithString() [1/2]

template<typename T >

bool AAX_CParameter< T >::SetValueWithString | ( | const AAX_IString & | value | ) |
| virtual

Sets the parameter's value as a string.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from string was successful
  false | The conversion from string was unsuccessful

Implements AAX_IParameter.

## ◆ UpdateNormalizedValue()

template<typename T >

void AAX_CParameter< T >::UpdateNormalizedValue | ( | double | newNormalizedValue | ) |
| virtual

Sets the parameter's state given a normalized value.

This is the second half of the parameter setting operation that is initiated with a call to SetValue(). Parameters should not be set directly using this method; instead, use SetValue().

Parameters

  [in] | newNormalizedValue | Normalized value that will be used to set the parameter's new state

Implements AAX_IParameter.

## ◆ SetValue()

template<typename T >

void AAX_CParameter< T >::SetValue | ( | T | newValue | ) |

Initiates a host request to set the parameter's value.

This method normalizes the provided value and sends a request for the value change to the AAX host. The host responds with a call to AAX_IParameter::UpdateNormalizedValue() to complete the set operation.

Parameters

  [in] | newValue | The parameter's new value

## ◆ GetValue()

template<typename T >

T AAX_CParameter< T >::GetValue

Returns the parameter's value.

This is the parameter's real, logical value and should not be normalized

## ◆ SetDefaultValue()

template<typename T >

void AAX_CParameter< T >::SetDefaultValue | ( | T | newDefaultValue | ) |

Set the parameter's default value.

This is the parameter's real, logical value and should not be normalized

Parameters

  [in] | newDefaultValue | The parameter's new default value

## ◆ GetDefaultValue()

template<typename T >

T AAX_CParameter< T >::GetDefaultValue

Returns the parameter's default value.

This is the parameter's real, logical value and should not be normalized

## ◆ TaperDelegate()

template<typename T >

const AAX_ITaperDelegate< T > * AAX_CParameter< T >::TaperDelegate

Returns a reference to the parameter's taper delegate.

## ◆ DisplayDelegate()

template<typename T >

const AAX_IDisplayDelegate< T > * AAX_CParameter< T >::DisplayDelegate

Returns a reference to the parameter's display delegate.

## ◆ GetValueAsString() [2/2]

bool AAX_CParameter< AAX_CString >::GetValueAsString | ( | AAX_IString * | value | ) | const
| virtual

Retrieves the parameter's value as a string.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion to string was successful
  false | The conversion to string was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithBool() [2/2]

bool AAX_CParameter< bool >::SetValueWithBool | ( | bool | value | ) |
| virtual

Sets the parameter's value as a bool.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from bool was successful
  false | The conversion from bool was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithInt32() [2/2]

bool AAX_CParameter< int32_t >::SetValueWithInt32 | ( | int32_t | value | ) |
| virtual

Sets the parameter's value as an int32_t.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from int32_t was successful
  false | The conversion from int32_t was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithFloat() [2/2]

bool AAX_CParameter< float >::SetValueWithFloat | ( | float | value | ) |
| virtual

Sets the parameter's value as a float.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from float was successful
  false | The conversion from float was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithDouble() [2/2]

bool AAX_CParameter< double >::SetValueWithDouble | ( | double | value | ) |
| virtual

Sets the parameter's value as a double.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from double was successful
  false | The conversion from double was unsuccessful

Implements AAX_IParameter.

## ◆ SetValueWithString() [2/2]

bool AAX_CParameter< AAX_CString >::SetValueWithString | ( | const AAX_IString & | value | ) |
| virtual

Sets the parameter's value as a string.

Parameters

  [out] | value | The parameter's real value. Set only if conversion is successful.

Return values

  true | The conversion from string was successful
  false | The conversion from string was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromBool() [2/2]

bool AAX_CParameter< bool >::GetNormalizedValueFromBool | ( | bool | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts a bool to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromInt32() [2/2]

bool AAX_CParameter< int32_t >::GetNormalizedValueFromInt32 | ( | int32_t | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts an integer to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromFloat() [2/2]

bool AAX_CParameter< float >::GetNormalizedValueFromFloat | ( | float | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts a float to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetNormalizedValueFromDouble() [2/2]

bool AAX_CParameter< double >::GetNormalizedValueFromDouble | ( | double | value,
|  | double * | normalizedValue
| ) |  | const
| virtual

Converts a double to a normalized parameter value.

Parameters

  [in] | value | A value for the parameter
  [out] | normalizedValue | The normalized parameter value associated with value

Return values

  true | The value conversion was successful
  false | The value conversion was unsuccessful

Implements AAX_IParameter.

## ◆ GetBoolFromNormalizedValue() [2/2]

bool AAX_CParameter< bool >::GetBoolFromNormalizedValue | ( | double | normalizedValue,
|  | bool * | value
| ) |  | const
| virtual

Converts a normalized parameter value to a bool representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to bool was successful
  false | The conversion to bool was unsuccessful

Implements AAX_IParameter.

## ◆ GetInt32FromNormalizedValue() [2/2]

bool AAX_CParameter< int32_t >::GetInt32FromNormalizedValue | ( | double | normalizedValue,
|  | int32_t * | value
| ) |  | const
| virtual

Converts a normalized parameter value to an integer representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to int32_t was successful
  false | The conversion to int32_t was unsuccessful

Implements AAX_IParameter.

## ◆ GetFloatFromNormalizedValue() [2/2]

bool AAX_CParameter< float >::GetFloatFromNormalizedValue | ( | double | normalizedValue,
|  | float * | value
| ) |  | const
| virtual

Converts a normalized parameter value to a float representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to float was successful
  false | The conversion to float was unsuccessful

Implements AAX_IParameter.

## ◆ GetDoubleFromNormalizedValue() [2/2]

bool AAX_CParameter< double >::GetDoubleFromNormalizedValue | ( | double | normalizedValue,
|  | double * | value
| ) |  | const
| virtual

Converts a normalized parameter value to a double representing the corresponding real value.

Parameters

  [in] | normalizedValue | The normalized value to convert
  [out] | value | The converted value. Set only if conversion is successful.

Return values

  true | The conversion to double was successful
  false | The conversion to double was unsuccessful

Implements AAX_IParameter.

## Member Data Documentation

## ◆ mNames

template<typename T >

AAX_CStringAbbreviations AAX_CParameter< T >::mNames
| protected

## ◆ mAutomatable

template<typename T >

bool AAX_CParameter< T >::mAutomatable
| protected

## ◆ mNumSteps

template<typename T >

uint32_t AAX_CParameter< T >::mNumSteps
| protected

## ◆ mControlType

template<typename T >

AAX_EParameterType AAX_CParameter< T >::mControlType
| protected

## ◆ mOrientation

template<typename T >

AAX_EParameterOrientation AAX_CParameter< T >::mOrientation
| protected

## ◆ mTaperDelegate

template<typename T >

AAX_ITaperDelegate<T>* AAX_CParameter< T >::mTaperDelegate
| protected

## ◆ mDisplayDelegate

template<typename T >

AAX_IDisplayDelegate<T>* AAX_CParameter< T >::mDisplayDelegate
| protected

## ◆ mAutomationDelegate

template<typename T >

AAX_IAutomationDelegate* AAX_CParameter< T >::mAutomationDelegate
| protected

## ◆ mNeedNotify

template<typename T >

bool AAX_CParameter< T >::mNeedNotify
| protected

## ◆ mValue

template<typename T >

AAX_CParameterValue<T> AAX_CParameter< T >::mValue
| protected

## ◆ mDefaultValue

template<typename T >

T AAX_CParameter< T >::mDefaultValue
| protected

The documentation for this class was generated from the following file:

- AAX_CParameter.h